# call of the index preparing program connected to file $main_file   
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University

proc index {f austext} {

  upvar 1 $austext a

  global  vv index inoptions main_file isuffe isuffa dirprefix

  writescr0 $f ""
  set a ""

  if {$dirprefix==""} {set mfile $main_file} else {set mfile [stripdir $main_file]} 

  if {$mfile==""} {set a "${a}***** $vv(ea1)\n"; mybell 2; return}

  writescr0 $f "[datime] $vv(in1) \"$mfile\"\n"


  if { [file exists $mfile$isuffe] } { # --> index preparing (makeindex)

    unlink -nocomplain $mfile.ilg
    eval mkCmd_wait $f $index [list "$inoptions $mfile"]

  } else {      # input file for indexpreparing not found!

   set a "${a}\n***** $vv(aus5)  $mfile$isuffe  $vv(ea4)\n      $vv(in2)\n"
   set a "${a}        \\documentstyle\[...,makeidx,...\]\{...\}\n"
   set a "${a}        ...\n"
   set a "${a}        \\makeindex\n"
   set a "${a}        \\begin\{document\}\n"
   set a "${a}        ... \\index\{...\} ...\n"
   set a "${a}        \\printindex\n"
   set a "${a}        \\end\{document\}\n"
   mybell 2

  }

}
